<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

class AbookControllerAuthor extends AbookController
{
	function __construct()
	{
		parent::__construct();
		// Register Extra tasks
		$this->registerTask( 'add'  , 	'edit' );
		$this->registerTask( 'apply',   'save' );
	}

	function display()
	{
		global $mainframe, $option;
                JRequest::setVar( 'view', 'authors' );
                parent::display();
	}

	function edit()
	{
		JRequest::setVar( 'view', 'author' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);
		
		// Checkout the author
                $model = $this->getModel('author');
                $model->checkout();
		
		parent::display();
	}

	function save()
	{
		JRequest::checkToken() or die( 'Invalid Token' );
		$model = $this->getModel('author');
		$post   = JRequest::get('post');
		$post['id']    = JRequest::getVar( 'cid', '', 'post', 'int' );
		$post['html'] = JRequest::getVar('html', '', 'post', 'string', JREQUEST_ALLOWRAW);
                $task           = JRequest::getCmd( 'task' );
                
		if ($returnid = $model->store($post)) {
                	switch ($task)
                	{
                        	case 'apply':
                                	$link = 'index.php?option=com_abook&controller=author&task=edit&cid[]='. $returnid ;
					$msg = JText::_( 'SUCCESSFULLY APPLY CHANGES TO AUTHOR' );
                                	break;

                        	case 'save':
                        	default:
                                	$link = 'index.php?option=com_abook&controller=author';
					$msg = JText::_( 'SUCCESSFULLY SAVED CHANGES TO AUTHOR' );
                                	break;
                	}
		} else {
			$msg = JText::_( 'AN ERROR HAS OCCURRED' );
		}

                // Checkout the author 
                $model = $this->getModel('author');
                $model->checkin();

		$this->setRedirect($link, $msg);
	}

	function remove()
	{
		$model = $this->getModel('author');
		if(!$model->delete()) {
			$msg = JText::_( 'ONE OR MORE ITEMS COULD NOT BE DELETED' );
		} else {
			$msg = JText::_( 'ITEM(S) DELETED' );
		}

		$this->setRedirect( 'index.php?option=com_abook&controller=author', $msg );
	}

	function cancel()
	{
		$msg = JText::_( 'OPERATION CANCELLED' );
                // sblocca il lucchetto
                $model = $this->getModel('author');
                $model->checkin();
		$this->setRedirect( 'index.php?option=com_abook&controller=author', $msg );
	}
}
