<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

class AbookControllerCategory extends AbookController
{
	function __construct()
	{
		parent::__construct();
		// Register Extra tasks
		$this->registerTask( 'add'  , 	'edit' );
		$this->registerTask( 'apply',   'save' );
		$this->registerTask( 'accesspublic',    'access' );
                $this->registerTask( 'accessregistered','access' );
                $this->registerTask( 'accessspecial',   'access' );
	}

	function display()
	{
	global $mainframe, $option;
                JRequest::setVar( 'view', 'categories' );
                parent::display();
	}

	function edit()
	{
		JRequest::setVar( 'view', 'category' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

                // Checkout the category controlla che non sia già in uso
                $model = $this->getModel('category');
                $model->checkout();

		parent::display();
	}

        function save()
        {
		JRequest::checkToken() or die( 'Invalid Token' );
                $model = $this->getModel('category');
		$post = JRequest::get( 'post' );
                $post['id']    = JRequest::getVar( 'cid', '', 'post', 'int' );
                $post['description'] = JRequest::getVar('description', '', 'post', 'string', JREQUEST_ALLOWRAW);
                //il nome è uguale al titolo
                $post['title']=JRequest::getVar('name', '', 'post', 'string');
                $task           = JRequest::getCmd( 'task' );

                if ($returnid = $model->store($post)) {
                        switch ($task)
                        {
                                case 'apply':
                                        $link = 'index.php?option=com_abook&controller=category&task=edit&cid[]='. $returnid ;
                                        $msg = JText::_( 'SUCCESSFULLY APPLY CHANGES TO CATEGORY' );
                                        break;

                                case 'save':
                                default:
                                        $link = 'index.php?option=com_abook&controller=category';
                                        $msg = JText::_( 'SUCCESSFULLY SAVED CHANGES TO CATEGORY' );
                                        break;
                        }
                } else {
                        $msg = JText::_( 'AN ERROR HAS OCCURRED' );
                }

                // Checkout the category controlla che non sia già in uso
                $model->checkin();
                $this->setRedirect($link, $msg);
        }

	function remove()
	{
		$model = $this->getModel('categories');
		if(!$model->delete()) {
			$msg = JText::_( 'ONE OR MORE ITEMS COULD NOT BE DELETED' );
		} else {
			$msg = JText::_( 'ITEM(S) DELETED' );
		}

		$this->setRedirect( 'index.php?option=com_abook&controller=category', $msg );
	}

	function cancel()
	{
		$msg = JText::_( 'OPERATION CANCELLED' );
                // sblocca il lucchetto
                $model = $this->getModel('category');
                $model->checkin();
		$this->setRedirect( 'index.php?option=com_abook&controller=category', $msg );
	}

        function orderup()
        {
                $model = $this->getModel('categories');
                $model->move(-1);

                $this->setRedirect( 'index.php?option=com_abook&controller=category');
        }

        function orderdown()
        {
                $model = $this->getModel('categories');
                $model->move(1);

                $this->setRedirect( 'index.php?option=com_abook&controller=category');
        }

        function saveorder()
        {
                $cid    = JRequest::getVar( 'cid', array(0), 'post', 'array' );
                $order  = JRequest::getVar( 'order', array(0), 'post', 'array' );
                JArrayHelper::toInteger($order, array(0));

                $model = $this->getModel('categories');
                $model->saveorder($cid, $order);

                $msg = JText::_( 'NEW ORDERING SAVED');
                $this->setRedirect( 'index.php?option=com_abook&controller=category', $msg );
        }

        function access( )
        {
                global $option;

                $cid            = JRequest::getVar( 'cid', array(0), 'post', 'array' );
                $id                     = $cid[0];
                $task           = JRequest::getVar( 'task' );

                if ($task == 'accesspublic') {
                        $access = 0;
                } elseif ($task == 'accessregistered') {
                        $access = 1;
                } else {
                        $access = 2;
                }

                $model = $this->getModel('category');
                $model->access( $id, $access );

                $this->setRedirect('index.php?option='. $option .'&controller=category' );
        }

	function publish()
        {
                $cid    = JRequest::getVar( 'cid', array(0), 'post', 'array' );

                if (!is_array( $cid ) || count( $cid ) < 1) {
                        JError::raiseError(500, JText::_( 'SELECT AN ITEM TO PUBLISHED' ) );
                }

                $model = $this->getModel('categories');
                if(!$model->publish($cid, 1)) {
                        echo "<script> alert('".$model->getError()."'); window.history.go(-1); </script>\n";
                }

                $total = count( $cid );
                $msg    = $total.' '.JText::_('CATEGORY PUBLISHED');

                $this->setRedirect( 'index.php?option=com_abook&controller=category', $msg );
        }

        function unpublish()
        {
                $cid    = JRequest::getVar( 'cid', array(0), 'post', 'array' );

                if (!is_array( $cid ) || count( $cid ) < 1) {
                        JError::raiseError(500, JText::_( 'SELECT AN ITEM TO UNPUBLISHED' ) );
                }

                $model = $this->getModel('categories');
                if(!$model->publish($cid, 0)) {
                        echo "<script> alert('".$model->getError()."'); window.history.go(-1); </script>\n";
                }

                $total = count( $cid );
                $msg    = $total.' '.JText::_('CATEGORY UNPUBLISHED');

                $this->setRedirect( 'index.php?option=com_abook&controller=category', $msg );
        }
}
