<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.filesystem.file');
class AbookControllerImportexport extends AbookController
{
	function __construct()
	{
		parent::__construct();
		// Register Extra tasks
		$this->registerTask( 'import'  , 	'import' );
		$this->registerTask( 'export',   'export' );
	}

	function display()
	{
		global $mainframe, $option;
                	JRequest::setVar( 'view', 'importexport' );
	                parent::display();
	}


        function export()
        {
		JRequest::checkToken() or die( 'Invalid Token' );
                $post   = JRequest::get('post');
		$post['type']    = JRequest::getVar( 'type', '', 'post', 'int' );
		$link = 'index.php?option=com_abook&controller=importexport&format=raw';
		$model = $this->getModel('importexport');
		$model->setExportType($post);
                $this->setRedirect($link);
        }

	function import() {
		$model = $this->getModel('importexport');
		$post['type2']    = JRequest::getVar( 'type2', '', 'post', 'int' );
		$post['category2']    = JRequest::getVar( 'category2', '', 'post', 'int' );
	        $importfile = JRequest::getVar('import_file', null, 'files', 'array' );
		$link = 'index.php?option=com_abook&controller=importexport';
		$filename = JFile::makeSafe($importfile['name']);
		$src = $importfile['tmp_name'];
		$dest = JPATH_COMPONENT . DS . "uploads" . DS . $filename;
		JFile::upload($src, $dest);

		switch ($post['type2']){
                        case 1:
				if (JFile::getExt($filename)=="sql"){
					if ($returncount = $model->importSql($filename, $post['category2'])) {
                                		$msg = JText::_( 'SUCCESSFULLY MYSQL IMPORT' );
					}else{
						$msg = JText::_( 'AN ERROR HAS OCCURRED' );
					}
				}else{
					$msg = JText::_( 'ERROR SQL EXT' );
					$msgtype = 'error';
				}
                                break;
                        case 2:
				if (JFile::getExt($filename)=="csv"){
					$returncount = $model->importCsv($dest, $post['category2']);
                                	if ($returncount > 0) {
                                        	$msg = JText::sprintf( 'SUCCESSFULLY CSV IMPORT', $returncount);
						$msgtype = 'message';
        	                        }else{
                	                        $msg = JText::_( 'AN ERROR HAS OCCURRED');
						$msgtype = 'error';
                                	}
				}else{
                                        $msg = JText::_( 'ERROR CSV EXT' );
					$msgtype = 'error';
                                }
                                break;
                        default:
                                $msg = JText::_( 'SELECT A IMPORT TYPE' );
				$msgtype = 'error';
                                break;
		}
		$this->setRedirect($link, $msg, $msgtype);
	}

}
