-- Struttura della tabella `#__author`
--

CREATE TABLE IF NOT EXISTS `#__abauthor` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `alias` varchar(255) NOT NULL,
  `image` varchar(255) NOT NULL default '',
  `html` mediumtext,
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;

-- --------------------------------------------------------

--
-- Struttura della tabella `#__abbook`
--

CREATE TABLE IF NOT EXISTS `#__abbook` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(255) default NULL,
  `subtitle` varchar(255) default NULL,
  `alias` varchar(255) NOT NULL,
  `ideditor` int(11) default NULL,
  `price` varchar(255) NOT NULL,
  `pag` int(11) default '0',
  `user_id` int(11) default NULL,
  `created_by_alias` varchar(255) NOT NULL,
  `html` mediumtext,
  `image` varchar(255) default NULL,
  `file` varchar(255) default NULL,
  `year` int(4) default NULL,
  `idlocation` int(10) default NULL,
  `idlibrary` int(10) default NULL,
  `vote` int(11) default '0',
  `numvote` int(11) default '0',
  `hits` int(11) default '0',
  `published` tinyint(3) NOT NULL default '0',
  `ordering` int(11) NOT NULL default '0',
  `catid` int(11) default NULL,
  `qty` int(11) default NULL,
  `isbn` varchar(255) default NULL,
  `approved` tinyint(1) default '0',
  `userid` int(11) default NULL,
  `url` varchar(255) default NULL,
  `url_label` varchar(255) default NULL,
  `dateinsert` datetime default NULL,
  `catalogo` varchar(15) default NULL,
  `checked_out` varchar(11) NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `access` tinyint(3) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `note` varchar(255) NOT NULL,
  `editedby` int(1) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `catid` (`catid`),
  KEY `access` (`access`),
  KEY `checked_out` (`checked_out`),
  KEY `published` (`published`),
  KEY `ordering` (`ordering`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;

-- --------------------------------------------------------

--
-- Struttura della tabella `#__abbookauth`
--

CREATE TABLE IF NOT EXISTS `#__abbookauth` (
  `aid` int(6) NOT NULL auto_increment,
  `idbook` int(11) NOT NULL default '0',
  `idauth` int(11) NOT NULL default '0',
  PRIMARY KEY  (`aid`),
  KEY `idx_idbook` (`idbook`),
  KEY `idx_idauth` (`idauth`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;

-- --------------------------------------------------------

--
-- Struttura della tabella `#__abcategories`
--

CREATE TABLE IF NOT EXISTS `#__abcategories` (
  `id` int(11) NOT NULL auto_increment,
  `parent_id` int(11) NOT NULL default '0',
  `title` varchar(255) NOT NULL default '',
  `name` varchar(255) NOT NULL default '',
  `alias` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `published` tinyint(1) NOT NULL default '0',
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `editor` varchar(50) default NULL,
  `ordering` int(11) NOT NULL default '0',
  `access` tinyint(3) unsigned NOT NULL default '0',
  `count` int(11) NOT NULL default '0',
  `params` text NOT NULL,
  `catimage` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `cat_idx` (`published`,`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `access` (`access`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;

-- --------------------------------------------------------
--
-- Struttura della tabella `#__abeditor`
--

CREATE TABLE IF NOT EXISTS `#__abeditor` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `alias` varchar(255) NOT NULL,
  `html` mediumtext,
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;

-- --------------------------------------------------------

--
-- Struttura della tabella `#__ablibrary`
--

CREATE TABLE IF NOT EXISTS `#__ablibrary` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `alias` varchar(255) NOT NULL,
  `html` mediumtext,
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;

-- --------------------------------------------------------

--
-- Struttura della tabella `#__ablocations`
--

CREATE TABLE IF NOT EXISTS `#__ablocations` (
  `id` int(11) NOT NULL auto_increment,
  `location` varchar(255) NOT NULL,
  `alias` varchar(255) default NULL,
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;
-- --------------------------------------------------------

--
-- Struttura della tabella `#__abrating`
--

CREATE TABLE IF NOT EXISTS `#__abrating` (
  `book_id` int(11) NOT NULL,
  `rating_sum` int(11) unsigned NOT NULL default '0',
  `rating_count` int(11) unsigned NOT NULL default '0',
  `lastip` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`book_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
