<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class AbookModelAbook extends JModel
{
	var $_books = null;
        var $_categories = null;
        var $_authors = null;
	var $_editors = null;
	var $_libraries = null;
	var $_locations = null;

        function __construct()
        {
                parent::__construct();
        }

	function getBooks()
        {
                $_books = array();
		$query = 'SELECT count(*)'
                                        . ' FROM #__abbook'
                                        . ' WHERE published = 1'
                                        ;

                $this->_db->SetQuery($query);
                $_books['published'] = $this->_db->loadResult();

		$query = 'SELECT count(*)'
                                        . ' FROM #__abbook'
                                        . ' WHERE published = 0'
                                        ;

                $this->_db->SetQuery($query);
                $_books['unpublished'] = $this->_db->loadResult();

		$_books['total'] = array_sum($_books);
		
		return $_books;
	}

	function getCategories()
        {
                $_categories = array();
                $query = 'SELECT count(*)'
                                        . ' FROM #__abcategories'
                                        . ' WHERE published = 1'
                                        ;

                $this->_db->SetQuery($query);
                $_categories['published'] = $this->_db->loadResult();

                $query = 'SELECT count(*)'
                                        . ' FROM #__abcategories'
                                        . ' WHERE published = 0'
                                        ;

                $this->_db->SetQuery($query);
                $_categories['unpublished'] = $this->_db->loadResult();

                $_categories['total'] = array_sum($_categories);

                return $_categories;
        }

	function getAuthors()
        {
                $_authors = array();
                $query = 'SELECT count(*)'
                                        . ' FROM #__abauthor'
                                        ;

                $this->_db->SetQuery($query);
                $_authors['total'] = $this->_db->loadResult();

                return $_authors;
        }

	function getEditors()
        {
                $_editors = array();
                $query = 'SELECT count(*)'
                                        . ' FROM #__abeditor'
                                        ;

                $this->_db->SetQuery($query);
                $_editors['total'] = $this->_db->loadResult();

                return $_editors;
        }

	function getLibraries()
        {
                $_libraries = array();
                $query = 'SELECT count(*)'
                                        . ' FROM #__ablibrary'
                                        ;

                $this->_db->SetQuery($query);
                $_libraries['total'] = $this->_db->loadResult();

                return $_libraries;
        }	

	function getLocations()
        {
                $_locations = array();
                $query = 'SELECT count(*)'
                                        . ' FROM #__ablocations'
                                        ;

                $this->_db->SetQuery($query);
                $_locations['total'] = $this->_db->loadResult();

                return $_locations;
        }

	function getMostrated()
        {
                // Lets load the data if it doesn't already exist
                if (empty( $this->_mostrated ))
                {
			$query = "SELECT a.title, a.id, "
                	. ' ROUND( v.rating_sum / v.rating_count ) AS rating, v.rating_count '
                	. "\n FROM #__abbook AS a"
                	. ' LEFT JOIN #__abrating AS v ON a.id = v.book_id'
                	. ' GROUP BY a.id '
                	. ' ORDER BY v.rating_count DESC'
                	;
                        $this->_mostrated = $this->_getList( $query, 0, 10 );
                }
                return $this->_mostrated;
        }

	function getMostviewed()
        {
                // Lets load the data if it doesn't already exist
                if (empty( $this->_mostviewed ))
                {
                        $query = "SELECT title, id, hits "
                        	. " FROM #__abbook"
                        	. ' ORDER BY hits DESC'
                        	;
                        $this->_mostviewed = $this->_getList( $query, 0, 10 );
                }
                return $this->_mostviewed;
        }
}
?>
