<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class AbookModelAuthor extends JModel
{
        var $_id = null;
        var $_data = null;

	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid', array(0), '', 'array');
		$this->setId((int)$array[0]);
	}

	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}

	function &getData()
	{
		// Load the data
		if (empty( $this->_data )) {
			$query = ' SELECT * FROM #__abauthor '.
					'  WHERE id = '.$this->_id;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
		}
		if (!$this->_data) {
			$this->_data = new stdClass();
			$this->_data->id = 0;
			$this->_data->name = null;
			$this->_data->alias = null;
			$this->_data->html = null;
			$this->_data->image = null;
		}
		return $this->_data;
	}

	function store($data)
	{	
		$row =& $this->getTable();

		// Bind the form fields to the table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Make sure the record is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError( $row->getErrorMsg() );
			return false;
		}
		//se non funziona rimetti return true;
		return $row->id;
	}

	function delete()
	{
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

		$row =& $this->getTable();

		if (count( $cids )) {
			foreach($cids as $cid) {
				// Make sure the record is valid
                                if (!$row->checkdel($cid)) {
                                        $this->setError($this->_db->getErrorMsg());
                                	return false;
                                }
				if (!$row->delete( $cid )) {
					$this->setError( $row->getErrorMsg() );
					return false;
				}
			}
		}
		return true;
	}

        function checkin()
        {
                if ($this->_id)
                {
                        $author = & $this->getTable();
                        if(! $author->checkin($this->_id)) {
                                $this->setError($this->_db->getErrorMsg());
                                return false;
                        }
                }
                return false;
        }

        function checkout($uid = null)
        {
                if ($this->_id)
                {
                        // Make sure we have a user id to checkout the article with
                        if (is_null($uid)) {
                                $user   =& JFactory::getUser();
                                $uid    = $user->get('id');
                        }
                        // Lets get to it and checkout the thing...
                        $author = & $this->getTable();
                        if(!$author->checkout($uid, $this->_id)) {
                                $this->setError($this->_db->getErrorMsg());
                                return false;
                        }
                        return true;
                }
                return false;
        }
}
