<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class AbookModelBook extends JModel
{
	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid', array(0), '', 'array');
		$this->setId((int)$array[0]);
	}

	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}

	function &getData()
	{
		// Load the data
		if (empty($this->_data)) {
			$row =& $this->getTable();
                	if (!$row->load($this->_id)) {
                       		$this->setError($this->_db->getErrorMsg());
               		}else{
				$this->_data = $row;
			}
		}		
		if (!$this->_data)
                {
			$this->_data = new stdClass();
                        $this->_data->id = 0;
                        $this->_data->title = null;
                        $this->_data->subtitle = null;
			$this->_data->alias = null;
			$this->_data->access = 0;
			$this->_data->catid = 0;
			$this->_data->idlibrary = 0;
			$this->_data->ideditor = 0;
			$this->_data->idlocation = 0;
			$this->_data->hits = 0;
			$this->_data->year = null;
			$this->_data->catalogo = null;
			$this->_data->price = null;
			$this->_data->pag = null;
			$this->_data->url = null;
			$this->_data->url_label = null;
			$this->_data->isbn = null;
			$this->_data->created_by_alias = null;
			$this->_data->metakey = null;
			$this->_data->metadesc = null;
			$this->_data->image = null;
			$this->_data->file = null;
			$this->_data->html = null;
			$this->_data->note = null;
			$weblink->ordering = 0;
		}
		return $this->_data;
	}

	function &getRating() {
                if (empty( $this->_rating )) {
                        $query = ' SELECT ROUND( rating_sum / rating_count ) AS rating, rating_count'
                        . ' FROM #__abrating'
			. '  WHERE book_id = '.$this->_id;	
                        ;
                        $this->_db->setQuery( $query );
                        $this->_rating = $this->_db->loadObject();
                }
		if (!$this->_rating)
                {
			$this->_rating = new stdClass();
			$this->_rating->rating=null;
			$this->_rating->rating_count=null;
		}
			
                return $this->_rating;
        }

	function &getEditorslist() {
		if (empty( $this->_editorslist )) {
                        $query = ' SELECT * '
			. ' FROM #__abeditor'
			. ' ORDER BY name'
			;
			$this->_db->setQuery( $query );	
			$this->_editorslist = $this->_getList( $query );
                }

                return $this->_editorslist; 
        }


        function &getAuthorslist() {
                if (empty( $this->_authorslist )) {
                        $query = ' SELECT * '
                        . ' FROM #__abauthor'
			. ' ORDER BY name'
                        ;
                        $this->_db->setQuery( $query );
                        $this->_authorslist = $this->_getList( $query );
                }

                return $this->_authorslist;
        }

        function &getBooksAuthorslist() {
                if (empty( $this->_booksauthorslist )) {
                        $query = ' SELECT * '
                        . ' FROM #__abbookauth JOIN #__abauthor ON #__abbookauth.idauth = #__abauthor.id'
			. ' WHERE idbook = '.$this->_id
			. ' ORDER BY name'
			;
                        $this->_db->setQuery( $query );
                        $this->_booksauthorslist = $this->_getList( $query );
                }

                return $this->_booksauthorslist;
        }

        function &getCategorieslist() {
                if (empty( $this->_categorieslist )) {
                        $query = ' SELECT *'
                        . ' FROM #__abcategories'
			. ' ORDER BY name'
                        ;
                        $this->_db->setQuery( $query );
                        $rows = $this->_getList( $query );
                }
                $children = array();
                        // first pass - collect children
                        foreach ($rows as $v ){
                                $pt = $v->parent_id;
                                $list = @$children[$pt] ? $children[$pt] : array();
                                array_push( $list, $v );
                                $children[$pt] = $list;
                        }
                        // second pass - get an indent list of the items
			JHTML::addIncludePath(JPATH_COMPONENT_SITE.DS.'helpers');
                        $this->_categorieslist = JHTML::_('menu.treerecurse', 0, '', '', array(), $children);

                return $this->_categorieslist;
        }

        function &getLocationslist() {
                if (empty( $this->_locationslist )) {
                        $query = ' SELECT * '
                        . ' FROM #__ablocations'
			. ' ORDER BY location'
                        ;
                        $this->_db->setQuery( $query );
                        $this->_locationslist = $this->_getList( $query );
                }

                return $this->_locationslist;
        }

        function &getLibrarieslist() {
                if (empty( $this->_librarieslist )) {
                        $query = ' SELECT * '
                        . ' FROM #__ablibrary'
			. ' ORDER BY name'
                        ;
                        $this->_db->setQuery( $query );
                        $this->_librarieslist = $this->_getList( $query );
                }

                return $this->_librarieslist;
        }

	function store($data)
	{
		global $mainframe;	
		$row =& $this->getTable();

		// Bind the form fields to the table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		if (!$row->id) {
                        $where = 'catid = ' . (int) $row->catid ;
                        $row->ordering = $row->getNextOrder( $where );
                }

		// Make sure the record is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError( $row->getErrorMsg() );
			return false;
		}
		return $row->id;
	}

	function storeauthor($id, $idauthors)
        {
		$booksauthorslist['aid'] = 0;
		$booksauthorslist['idbook'] = $id;

                global $mainframe;
		$row1 =& $this->getTable('bookauth2');
		if (!$row1->delete($id)) {
                        $this->setError($this->_db->getErrorMsg());
                        return false;
                }
		$row2 =& $this->getTable('bookauth');
                //uno per volta
                foreach ($idauthors as $auth) { 
			$booksauthorslist['idauth']=$auth;
                        if (!$row2->bind($booksauthorslist)) {
                                $this->setError($this->_db->getErrorMsg());
                                return false;
                        }

                        // Make sure the record is valid
                        if (!$row2->check()) {
                                $this->setError($this->_db->getErrorMsg());
                                return false;
                        }

                        // Store the web link table to the database
                        if (!$row2->store($booksauthorslist, $booksauthorslist['aid'])) {
                                $this->setError( $row2->getErrorMsg() );
                                return false;
                        }
		}
	}

	function delete()
	{
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );


		if (count( $cids )) {
			foreach($cids as $cid) {
				$row =& $this->getTable();
				if (!$row->delete( $cid )) {
					$this->setError( $row->getErrorMsg() );
					return false;
				}
				$row1 =& $this->getTable('bookauth2');
                		if (!$row1->delete($cid)) {
                        		$this->setError($this->_db->getErrorMsg());
                        		return false;
                		}
				
			}
		}
		return true;
	}

        function checkin()
        {
                if ($this->_id)
                {
                        $book = & $this->getTable();
                        if(! $book->checkin($this->_id)) {
                                $this->setError($this->_db->getErrorMsg());
                                return false;
                        }
                }
                return false;
        }


	function checkout($uid = null)
        {
                if ($this->_id)
                {
                        // Make sure we have a user id to checkout the article with
                        if (is_null($uid)) {
                                $user   =& JFactory::getUser();
                                $uid    = $user->get('id');
                        }
                        // Lets get to it and checkout the thing...
                        $book = & $this->getTable();
                        if(!$book->checkout($uid, $this->_id)) {
                                $this->setError($this->_db->getErrorMsg());
                                return false;
                        }

                        return true;
                }
                return false;
        }

	function access($id, $access)
        {
                $row  =& $this->getTable('book');

                $row->load( $id );
                $row->access = $access;

                if ( !$row->check() ) {
                        return $row->getError();
                }
                if ( !$row->store() ) {
                        return $row->getError();
                }

                return true;
        }

	function reset_rates()
	{
		$row =& $this->getTable('rating');
         	       if (!$row->delete( $this->_id )) {
                	       $this->setError( $row->getErrorMsg() );
                               return false;
                       }
	}	
}
