<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class AbookModelBookelement extends JModel
{
	var $_data;
        var $_total = null;
        var $_pagination = null;

        function __construct()
        {
                parent::__construct();


                global $mainframe, $option;

                // Get the pagination request variables
                $limit          = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
                $limitstart     = $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );


                $this->setState('limit', $limit);
                $this->setState('limitstart', $limitstart);

		//$array = JRequest::getVar('cid',  0, '', 'array');
                //$this->setId((int)$array[0]);
        }

	function _buildQuery()
	{
                $where          = $this->_buildContentWhere();
                $orderby        = $this->_buildContentOrderBy();
		$query =  ' SELECT a.*, cc.title AS category, ee.name AS editor, ee.id AS editorid, GROUP_CONCAT(bb.name) AS author '
			. ' FROM #__abbook AS a '
			. ' LEFT JOIN #__abcategories AS cc ON cc.id = a.catid '
			. ' LEFT JOIN #__abeditor AS ee ON ee.id = a.ideditor '
			. ' LEFT JOIN #__abbookauth AS aa ON aa.idbook = a.id '
			. ' LEFT JOIN #__abauthor AS bb ON bb.id=aa.idauth '
			. ' LEFT JOIN #__users AS u ON u.id = a.checked_out '
			. $where
			. ' GROUP BY a.id '
			. $orderby
		;
		return $query;
	}

	function getData()
	{
		// Lets load the data if it doesn't already exist
		if (empty( $this->_data ))
		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit')  );
		}

		return $this->_data;
	}
      
	  function getTotal()
        {
                // Lets load the total nr if it doesn't already exist
                if (empty($this->_total))
                {
                        $query = $this->_buildQuery();
                        $this->_total = $this->_getListCount($query);
                }

                return $this->_total;
        }

        function getPagination()
        {
                // Lets load the content if it doesn't already exist
                if (empty($this->_pagination))
                {
                        jimport('joomla.html.pagination');
                        $this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
                }

                return $this->_pagination;
        }

        function _buildContentOrderBy()
        {
                global $mainframe, $option;

                $filter_order = $mainframe->getUserStateFromRequest( $option.'.bookselement.filter_order', 'filter_order', 'a.title', 'cmd' );
                $filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'.bookselement.filter_order_Dir', 'filter_order_Dir', '', 'word' );

		$orderby = ' ORDER BY '.$filter_order .' '.$filter_order_Dir; //forse filter_order_dir non serve

                return $orderby;
        }

        function _buildContentWhere()
        {
                global $mainframe, $option;
		
		$db                                     =& JFactory::getDBO();
                $filter_state           = $mainframe->getUserStateFromRequest( $option.'.bookselement.filter_state', 'filter_state', '', 'word' );
		$filter_catid           = $mainframe->getUserStateFromRequest( $option.'.bookselement.filter_catid', 'filter_catid', 0, 'int' );
                $search                 = $mainframe->getUserStateFromRequest( $option.'.bookselement.search', 'search', '', 'string' );
                $search                 = JString::strtolower( $search );
                $where = array();

                /*
                * Filter state
                */
                if ( $filter_state != '' ) {
                        if ( $filter_state == 'P' ) {
                                $where[] = 'a.published = 1';
                        } else if ($filter_state == 'U' ) {
                                $where[] = 'a.published = 0';
                        }
                }
		
		if ($filter_catid > 0) {
                        $where[] = 'a.catid = '.(int) $filter_catid;
                }

                /*
                * Search venues
                */
		if ($search) {
                        $where[] = 'LOWER(a.title) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
                }

                $where          = ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );

                return $where;
        }
	
	function &getCategorieslist() {
                if (empty( $this->_categorieslist )) {
                        $query = ' SELECT *'
                        . ' FROM #__abcategories'
                        ;
                }
                if (empty($this->_categorieslist)) {
                        $this->_db->setQuery( $query );
                        $rows = $this->_getList( $query );
                }
                $children = array();
                        // first pass - collect children
                        foreach ($rows as $v ){
                                $pt = $v->parent_id;
                                $list = @$children[$pt] ? $children[$pt] : array();
                                array_push( $list, $v );
                                $children[$pt] = $list;
                        }
                        // second pass - get an indent list of the items
                        JHTML::addIncludePath(JPATH_COMPONENT_SITE.DS.'helpers');
                        $this->_categorieslist = JHTML::_('menu.treerecurse', 0, '', '', array(), $children);
                return $this->_categorieslist;
        }
}
