<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class AbookModelCategory extends JModel
{
	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid', array(0), '', 'array');
		$this->setId((int)$array[0]);
	}

	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}

	function &getData()
	{
		// Load the data
		if (empty( $this->_data )) {
			$query = ' SELECT * FROM #__abcategories '.
				'  WHERE id = '.$this->_id;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
		}
		if (!$this->_data) {
			$this->_data = new stdClass();
			$this->_data->id = 0;
			$this->_data->name = null;
			$this->_data->alias = null;
			$this->_data->parent_id = 0;
			$this->_data->published = 1;
			$this->_data->access = 0;
			$this->_data->ordering = null;
			$this->_data->description = null;
		}

		return $this->_data;
	}

	function &getCategorieslist2() {
                if (empty( $this->_categorieslist2 )) {
                        $query = ' SELECT *'
                        . ' FROM #__abcategories'
                        ;
                }
                if (empty($this->_categorieslist2)) {
                        $this->_db->setQuery( $query );
                        $rows = $this->_getList( $query );
                }
		$children = array();
                        // first pass - collect children
                        foreach ($rows as $v ){
                                $pt = $v->parent_id;
                                $list = @$children[$pt] ? $children[$pt] : array();
                                array_push( $list, $v );
                                $children[$pt] = $list;
                        }
                        // second pass - get an indent list of the items
			JHTML::addIncludePath(JPATH_COMPONENT_SITE.DS.'helpers');
                        $this->_categorieslist2 = JHTML::_('menu.treerecurse', 0, '', '', array(), $children);

                return $this->_categorieslist2;
        }
	
	function &getOrdering() {
	
		$query = 'SELECT ordering AS value, title AS text'
	        . ' FROM #__abcategories'
	        . ' ORDER BY ordering'
        	;
		$this->_Ordering=$query;
		return $this->_Ordering;
	}

	function store($data)
	{
		$row =& $this->getTable();

		// Bind the form fields to the table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Make sure the record is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		//impostare l'ordinamento nella nuova categoria
		if (!$row->id) {
                	$row->ordering = $row->getNextOrder();
        	}


		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError( $row->getErrorMsg() );
			return false;
		}

		return $row->id;
	}

        function access($id, $access)
        {
                $row  =& $this->getTable('category');

                $row->load( $id );
                $row->access = $access;

                if ( !$row->check() ) {
                        return $row->getError();
                }
                if ( !$row->store() ) {
                        return $row->getError();
                }

                return true;
        }

        function checkin()
        {
                if ($this->_id)
                {
                        $category = & $this->getTable();
                        if(! $category->checkin($this->_id)) {
                                $this->setError($this->_db->getErrorMsg());
                                return false;
                        }
                }
                return false;
        }

        function checkout($uid = null)
        {
                if ($this->_id)
                {
                        // Make sure we have a user id to checkout the article with
                        if (is_null($uid)) {
                                $user   =& JFactory::getUser();
                                $uid    = $user->get('id');
                        }
                        // Lets get to it and checkout the thing...
                        $category = & $this->getTable();
                        if(!$category->checkout($uid, $this->_id)) {
                                $this->setError($this->_db->getErrorMsg());
                                return false;
                        }

                        return true;
                }
                return false;
        }
}
