<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');
jimport( 'joomla.filesystem.file' );

class AbookModelImportexport extends JModel
{
	var $_categories = null;
	function __construct()
	{
		parent::__construct();

	}

	function &getCategories() {
                if (empty( $this->_categories )) {
                        $query = ' SELECT * '
                        . ' FROM #__abcategories'
                        ;
                        $this->_db->setQuery( $query );
                        $this->_categories = $this->_getList( $query );
                }

                return $this->_categories;
        }

	function setExportType($export){
		$session = JFactory::getSession();
                $session->set('export', $export, 'Abook');
	}

	function getExportType(){
                $session = JFactory::getSession();
                $export=$session->get('export', array(), 'Abook');
		switch ($export['type']){
                        case 1:
				$ext=".sql";
			break;
			case 2:
				$ext=".csv";
			break;
		}
		return $ext;
        }

	function getExport()
	{
		$session = JFactory::getSession();
                $export=$session->get('export', array(), 'Abook');
		switch ($export['type']){
			case 1:
				$tables= array('#__abauthor', '#__abbook', '#__abbookauth', '#__abcategories', '#__abeditor', '#__ablibrary', '#__ablocations', '#__abrating');
				foreach ($tables as $table){
					$file=$this->datadumpSql($table);
				}
			break;
			case 2:
				$file=$this->datadumpCsv($export['category']);
			break;
		}

		return $file;
	}

	function datadumpCsv ($category) {
                $result = '';
                $resrt = '';
		$category=($category==0)?'': 'WHERE catid='.$category;
                $query = 'SELECT title, subtitle, alias, ideditor, price, '
			. "pag, user_id, created_by_alias, html, image, file, "
                        . " year, idlocation, idlibrary, vote, numvote, hits, published, qty, isbn, approved, userid, url, "
                        . " url_label, dateinsert, catalogo, checked_out, checked_out_time, access, metakey, metadesc, note, editedby, "
			. " GROUP_CONCAT(#__abbookauth.idauth SEPARATOR ',') as autori "
			. ' FROM #__abbook '
			. ' LEFT JOIN #__abbookauth on #__abbookauth.idbook=#__abbook.id '
			. $category
			. ' GROUP BY #__abbook.id';
                $this->_db->setQuery($query);
                $rows = $this->_db->loadAssocList();
                foreach($rows as $row){
                        $resrt = '"';
                        while (list($key, $value) = each($row)) {
                                $resrt .= mysql_real_escape_string($value).'";"';
                        }
                        $resrt = substr($resrt,0,-2);
                        $resrt .= "\r\n";
                        $result .= $resrt;
                }
                echo $result;
                return;
        }

	function datadumpSql ($table) {
	        $result = '';
        	$resrt = '';
	        $reslt = "";
	        $query = 'SELECT * FROM '.$table;
		$this->_db->setQuery($query);
		$rows = $this->_db->loadAssocList();
	        foreach($rows as $row){
	                $reslt .= "INSERT INTO ".$table." (";
        	        $resrt .= ") VALUES ('";
                	while (list($key, $value) = each($row)) {
	                        $reslt .= $key.",";
        	                $resrt .= mysql_real_escape_string($value)."','";
                	}
                	$reslt = substr($reslt,0,-1);
                	$resrt = substr($resrt,0,-2);
	                $resrt .= ");\n";
        	        $result .= ($reslt.$resrt);
                	$reslt ='';
	                $resrt ='';
        	}
        	echo $result . "\n\n\n";
		return;
        }
	
	function importSql($filename) {
		$buffer = Jfile::read(JPATH_COMPONENT.DS.'uninstall.sql');
		$buffer .= Jfile::read(JPATH_COMPONENT.DS.'install.sql');
		$buffer .= Jfile::read(JPATH_COMPONENT.DS."uploads".DS.$filename);
                $queries = JDatabase::splitSql($buffer);
		if (count($queries) == 0) {
                	// No queries to process
                        return 0;
                }
		foreach ($queries as $query){
                	$query = trim($query);
                        if ($query != '' && $query{0} != '#') {
                        	$this->_db->setQuery($query);	
                                if (!$this->_db->query()) {
                                	JError::raiseWarning(1, 'JDatabase::query: '.JText::_('SQL Error')." ".$this->_db->stderr(true));
                                	return false;
                                }
                        }
                }
		Jfile::delete(JPATH_COMPONENT.DS."uploads".DS.$filename);
		return count($queries);
	}

	function importCsv($csvfile, $category) {
		$buffer = file($csvfile);
		$insertrows=0;
		for($i=0; $i<sizeof ($buffer); $i++) {
			$id=null;
			$authorsLine=array();
			$line = trim($buffer[$i]);
			//list($title, $subtitle, $alias, $gid, $gecos, $home, $shell) = explode(":", $data);
			//cerca l'ultimo ";" della stringa
			$pos=strripos($line, ';');
			$bookLine = preg_replace('/";"/', '","', substr($line, 0, $pos));
			//il "+ 1" serve per togliere il ";" all'inizio, poi tolgo gli apici e lo faccio diventare un array
			$authorsLine = explode(',', preg_replace('/"/', '', substr($line, $pos + 1)));
			$query=  " INSERT INTO #__abbook "
				." (title, subtitle, alias, ideditor, price, pag, user_id, created_by_alias, html, image, "
				." file, year, idlocation, idlibrary, vote, numvote, hits, published, qty, isbn, approved,"
				." userid, url, url_label, dateinsert, catalogo, checked_out, checked_out_time, access,"
				." metakey, metadesc, note, editedby, catid)"
				." VALUES (".$bookLine.",".$category.")";
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
 	                       JError::raiseWarning(1, 'JDatabase::query: '.JText::_('SQL Error')." ".$this->_db->stderr(true));
			}else{
				$id=$this->_db->insertid();
				$insertrows=($id > 0) ? $insertrows + 1 : $insertrows;
				if (count($authorsLine)>0 && isset($id)){
					foreach($authorsLine as $authorID){
						$query=  " INSERT INTO #__abbookauth "
							." (idbook, idauth)"
							." VALUES (".$id.",".$authorID.")";
						$this->_db->setQuery( $query );
						$this->_db->query();
					}
				}
			}
		}
		/*$query	= "LOAD DATA LOCAL INFILE '" . $csvfile . "' INTO TABLE #__abbook"
			. " FIELDS TERMINATED BY ';' ENCLOSED BY '\"' LINES TERMINATED BY "."'\\n'"
			. " (title, subtitle, alias, ideditor, price, pag, user_id, created_by_alias, html, image, file, "
			. " year, idlocation, idlibrary, vote, numvote, hits, published, qty, isbn, approved, userid, url, "
			. " url_label, dateinsert, catalogo, checked_out, checked_out_time, access, metakey, metadesc)"
			. " SET catid = ".$category;
		$this->_db->setQuery( $query );	
		$this->_db->query();
		$rows=$this->_db->getAffectedRows();*/
		Jfile::delete($csvfile);
		return $insertrows;
	}
}
