<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class AbookModelLibraries extends JModel
{
	var $_data;
	var $_total = null;
	var $_pagination = null;

        function __construct()
        {
                parent::__construct();

                global $mainframe, $option;

                // Get the pagination request variables
                $limit          = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
                $limitstart     = $mainframe->getUserStateFromRequest( $option.JRequest::getCmd( 'controller').'.limitstart', 'limitstart', 0, 'int' );

                // In case limit has been changed, adjust limitstart accordingly
                $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

                $this->setState('limit', $limit);
                $this->setState('limitstart', $limitstart);
        }

	function _buildQuery()
	{
                $where          = $this->_buildContentWhere();
                $orderby        = $this->_buildContentOrderBy();
		$query = ' SELECT * '
			. ' FROM #__ablibrary '
			. $where
                        . $orderby
		;
		return $query;
	}


        function _buildContentOrderBy()
        {
                global $mainframe, $option;

                $filter_order           = $mainframe->getUserStateFromRequest( $option.'.libraries.filter_order', 'filter_order', 'name', 'cmd' );
                $filter_order_Dir       = $mainframe->getUserStateFromRequest( $option.'.libraries.filter_order_Dir', 'filter_order_Dir', '', 'word' );

                if ($filter_order == 'name'){
                        $orderby        = ' ORDER BY name '.$filter_order_Dir;
                } else {
                        $orderby        = ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' ';
                }

                return $orderby;
        }

        function _buildContentWhere()
        {
                global $mainframe, $option;
                $db                                     =& JFactory::getDBO();
                $filter_order           = $mainframe->getUserStateFromRequest( $option.'.libraries.filter_order', 'filter_order', 'name', 'cmd' );
                $filter_order_Dir       = $mainframe->getUserStateFromRequest( $option.'.libraries.filter_order_Dir', 'filter_order_Dir', '', 'word' );
                $search                 = $mainframe->getUserStateFromRequest( $option.'.libraries.search', 'search', '', 'string' );
                $search                         = JString::strtolower( $search );

                $where = array();

                if ($search) {
                        $where[] = 'LOWER(name) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
                }

                $where          = ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );

                return $where;
        }

	function getData()
	{
		// Lets load the data if it doesn't already exist
		if (empty( $this->_data ))
		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_data;
	}

        function getTotal()
        {
                // Lets load the content if it doesn't already exist
                if (empty($this->_total))
                {
                        $query = $this->_buildQuery();
                        $this->_total = $this->_getListCount($query);
                }

                return $this->_total;
        }

        function getPagination()
        {
                // Lets load the content if it doesn't already exist
                if (empty($this->_pagination))
                {
                        jimport('joomla.html.pagination');
                        $this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
                }

                return $this->_pagination;
        }
}
