<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

class TableBook extends JTable
{
	var $id = null;
	var $title = null;
        var $alias = null;
	var $subtitle = null;
	var $year = null;
	var $idlocation = null;
	var $idlibrary = null;
        var $ideditor = null;
        var $category = null;
        var $rating = null;
        var $hits = null;
        var $published = null;
        var $approvazione = null;
        var $catid = null;
        var $dateinsert = null;
	var $isbn = null;
	var $price = null;
	var $pag = null;
	var $url = null;
	var $url_label = null;
	var $user_id = null;
	var $created_by_alias = null;
	var $html = null;
	var $note = null;
	var $image = null;
	var $file = null;
	var $state = null;
	var $ordering = null;
	var $catalogo = null;
	var $checked_out = 0;
        var $checked_out_time = 0;
	var $access = 0;
	var $metakey = null;
	var $metadesc = null;
	var $editedby = null;	

	function TableBook(& $db) {
		parent::__construct('#__abbook', 'id', $db);
	}

        function check()
        {
		if (trim($this->title) == '') {
                        $this->setError(JText::_('BOOK ITEM MUST HAVE A TITLE'));
                        return false;
                }
		if (trim($this->catid) == '') {
                        $this->setError(JText::_('YOU MUST SELECT A CATEGORY'));
                        return false;
                }

                $alias = JFilterOutput::stringURLSafe($this->title);

                if(empty($this->alias) || $this->alias === $alias ) {
                        $this->alias = $alias;
                }
		$datenow =JHTML::_('date', 'now','%Y-%m-%d %H:%M');
		if(empty($this->dateinsert) || $this->dateinsert === $datenow ) {
                        $this->dateinsert = $datenow;
                } 

                return true;
        }
}
