<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

class TableCategory extends JTable
{
	var $id = null;
	var $title = null;
	var $name = null;
	var $alias = null;
	var $catimage = null;
        var $description = null;
        var $published = null;
        var $access = 0;
	var $parent_id	=0;
	var $ordering = null;
        var $checked_out = 0;
        var $checked_out_time = 0;

	function TableCategory(& $db) {
		parent::__construct('#__abcategories', 'id', $db);
	}

        function check()
        {
		/** check for valid name */
                if (trim($this->name) == '') {
                        $this->setError(JText::_('CATEGORY ITEM MUST HAVE A NAME'));
                        return false;
                }

                $alias = JFilterOutput::stringURLSafe($this->name);

                if(empty($this->alias) || $this->alias === $alias ) {
                        $this->alias = $alias;
                }

		$query="SELECT id FROM #__abcategories";
		$this->_db->setQuery($query);
		$num = $this->_db->loadResult();
		if ($num ==0){
			return true;
		}
		/** check per impedire di impastare il parent di se stesso */
                $xid = $this->id;
		$xparent_id = $this->parent_id;
		if ($xparent_id ==0){
                        return true;
                }
                if ($xid == $xparent_id) {
                       	JError::raiseWarning('SOME_ERROR_CODE', JText::_('YOU CAN NOT TO SET THIS PARENT CATEGORY'));
                       	return false;
                }
		return true;
	}	
	function checkdel($cid)
	{
		//check per impedire la cancellazione di una categoria piena 
		$query = 'SELECT * FROM #__abbook WHERE catid = '.$cid;
                $this->_db->setQuery($query);
                $xid = $this->_db->loadResult();

		$query = 'SELECT * FROM #__abcategories WHERE parent_id  = '.$cid;
		$this->_db->setQuery($query);
		$xparent_id = $this->_db->loadResult();

                if ((count($xid) > 0)||(count($xparent_id) > 0)) {
                        JError::raiseWarning('SOME_ERROR_CODE', JText::_('YOU CAN NOT TO CANCEL A CATEGORY ALREADY USED IN A BOOK OR OTHER CATEGORY'));
                        return false;
                }	

                return true;
        }
}
