<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class AbookViewAbook extends JView {

	function display($tpl = null)
        {
                //Load pane behavior
                jimport('joomla.html.pane');

                //initialise variables
                $document       = & JFactory::getDocument();
                $pane           = & JPane::getInstance('sliders');
                $user           = & JFactory::getUser();

                //build toolbar
                JToolBarHelper::title( JText::_( 'ABOOK' ), 'main' );

                // Get data from the model
                $books      = & $this->get( 'Books');
                $authors       = & $this->get( 'authors');
                $categories        = & $this->get( 'Categories' );
		$editors       = & $this->get( 'editors');
		$libraries       = & $this->get( 'libraries');
		$locations       = & $this->get( 'locations');
		$mostrated      = & $this->get( 'mostrated');
		$mostviewed	= & $this->get( 'mostviewed');

                //add css and submenu to document
                $document->addStyleSheet('components'.DS.'com_abook'.DS.'css'.DS.'com_abook.css');

		JHTML::addIncludePath(JPATH_COMPONENT.DS.'helpers');
		$lists['credit']=JHTML::_('credit.credit');

                //assign vars to the template
                $this->assignRef('pane'                , $pane);
                $this->assignRef('books'               , $books);
                $this->assignRef('categories'          , $categories);
		$this->assignRef('authors'             , $authors);
		$this->assignRef('editors'             , $editors);		
		$this->assignRef('libraries'           , $libraries);
		$this->assignRef('locations'           , $locations);
                $this->assignRef('user'                , $user);
		$this->assignRef('mostrated'           , $mostrated);
		$this->assignRef('mostviewed'          , $mostviewed);
		$this->assignRef('lists'                , $lists);

                parent::display($tpl);

        }

	function quickiconButton( $link, $image, $text, $modal = 0 )
        {
                //initialise variables
                $lang           = & JFactory::getLanguage();
                ?>

                <div style="float:<?php echo ($lang->isRTL()) ? 'right' : 'left'; ?>;">
                        <div class="icon">
                                <?php
                                if ($modal == 1) {
                                        JHTML::_('behavior.modal');
                                ?>
                                        <a href="<?php echo $link.'&amp;tmpl=component'; ?>" style="cursor:pointer" class="modal" rel="{handler: 'iframe', size: {x: 650, y: 400}}">
                                <?php
                                } else {
                                ?>
                                        <a href="<?php echo $link; ?>">
                                <?php
                                }

                                        echo JHTML::_('image', 'administrator/components/com_abook/images/'.$image, $text );
                                ?>
                                        <span><?php echo $text; ?></span>
                                </a>
                        </div>
                </div>
                <?php
        }
}
?>
