<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );

class AbookViewAuthor extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option;
		$author		=& $this->get('Data');
		$isNew		= ($author->id < 1);
		$document       = & JFactory::getDocument();
                $document->addStyleSheet('components/'.$option.'/css/'.$option.'.css');		
		$text = $isNew ? JText::_( 'NEW' ) : JText::_( 'EDIT' );
		$icon = $isNew ? 'authoradd' : 'authoredit';
		JToolBarHelper::title( JText::_( 'AUTHOR' ).': <small>[ ' . $text.' ]</small>', $icon );
		JToolBarHelper::save();
		JToolBarHelper::apply();
		if ($isNew)  {
			JToolBarHelper::cancel();
		} else {
			// for existing items the button is renamed `close`
			JToolBarHelper::cancel( 'cancel', 'Close' );
		}
		$config =& JComponentHelper::getParams( 'com_abook' );
		$imageconfig=& JComponentHelper::getParams('com_media');
                $lists['img_path'] = $config->get( 'img_path' );
		$lists['image'] = JHTML::_('list.images', 'image', $author->image, '', '/images/'.$lists['img_path'].'/');

		JHTML::_('behavior.tooltip');

		JHTML::addIncludePath(JPATH_COMPONENT.DS.'helpers');
                $lists['credit']=JHTML::_('credit.credit');
		
		$this->assignRef('author',		$author);
		$this->assignRef('lists',              $lists);
		$this->assignRef( 'imageconfig',             $imageconfig);
		$this->assignRef( 'session',    JFactory::getSession());

		parent::display($tpl);
	}
}
