<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );

class AbookViewBook extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option;
		jimport('joomla.html.pane');
		$document       = & JFactory::getDocument();
                $document->addStyleSheet('components/'.$option.'/css/'.$option.'.css');
		$book		=& $this->get('Data');
		$lists['rating']           =& $this->get('Rating');
		$isNew		= ($book->id < 1);
		$user		= JFactory::getUser();
		$pane           = & JPane::getInstance('sliders');
		
		$text = $isNew ? JText::_( 'NEW' ) : JText::_( 'EDIT' );
		$icon=$isNew?"bookadd":"bookedit";
                JToolBarHelper::title(   JText::_( 'BOOK' ).': <small><small>[ ' . $text.' ]</small></small>', $icon );
                JToolBarHelper::save();
                JToolBarHelper::apply();
                if ($isNew)  {
                        JToolBarHelper::cancel();
                } else {
                        // for existing items the button is renamed `close`
                        JToolBarHelper::cancel( 'cancel', 'Close' );
                }
		//tiro fuori i dati dalla funzione geteditorslist scritta nel file models/jbok.php. basta richiamare Editorslist che è il return della funzione
		$editorslist          =& $this->get('Editorslist');

		//tiro fuori i dati dalla funzione getauthorslist scritta nel file models/jbok.php. basta richiamare Authorslist che è il return della funzione
		$authorslist          =& $this->get('Authorslist');
		$locationslist          =& $this->get('Locationslist');
		$librarieslist          =& $this->get('Librarieslist');

		$booksauthorslist          =& $this->get('Booksauthorslist');
		$cat          =& $this->get('Categorieslist');
		$top[]    = JHTML::_('select.option','0' , JText::_('SELECT A CATEGORY'), 'id', 'treename');
                $categorieslist=array_merge($top, $cat);

		//Get global parameters
		$params =& JComponentHelper::getParams( 'com_abook' );
		$imageconfig=& JComponentHelper::getParams('com_media');
                $img['img_path'] = $params->get( 'img_path' );
		//tendina con le immagini
		$lists['images'] = JHTML::_('list.images', 'image', $book->image, '', '/images/'.$img['img_path'].'/');

		// $lists può contenere tutti gli array che vuoi
		$lists['path'] = $img['img_path'];
		JHTML::addIncludePath(JPATH_COMPONENT.DS.'helpers');
		$lists['files'] = JHTML::_('files.files', 'file', $book->file, '', 'images'.DS.$params->get('file_path').DS);
		//aggiungo all'array la prima voce "seleziona un editore"
		$topeditor[]    = JHTML::_('select.option','0' , JText::_('SELECT A EDITOR'), 'id', 'name');
		$editorslist=array_merge($topeditor, $editorslist);
                $lists['ideditor'] = JHTML::_('select.genericlist', $editorslist, 'ideditor', 'class="inputbox" size="1"','id', 'name', $book->ideditor );

		//tutti gli autori
                $lists['author'] = JHTML::_('select.genericlist', $authorslist, 'author', 'class="inputbox" size="20" multiple="multiple"','id', 'name');
		//autori selezionati
                $lists['idauth'] = JHTML::_('select.genericlist', $booksauthorslist, 'idauth[]', 'class="inputbox" size="20" multiple="multiple"','id', 'name');

		$toplocation[]    = JHTML::_('select.option','0' , JText::_('SELECT A LOCATION'), 'id', 'location');
                $locationslist=array_merge($toplocation, $locationslist);
		$lists['location'] = JHTML::_('select.genericlist', $locationslist, 'idlocation', 'class="inputbox" size="1"','id', 'location', $book->idlocation);

		$toplibraries[]    = JHTML::_('select.option','0' , JText::_('SELECT A LIBRARY'), 'id', 'name');
                $librarieslist=array_merge($toplibraries, $librarieslist);
                $lists['library'] = JHTML::_('select.genericlist', $librarieslist, 'idlibrary', 'class="inputbox" size="1"','id', 'name', $book->idlibrary);

		//questa ha l'indentazone delle voci figlie
		$lists['catid'] = JHTML::_('select.genericlist', $categorieslist, 'catid', '','id', 'treename', $book->catid );

		$published = ($book->id) ? $book->published : 1;
                $lists['published']             = JHTML::_('select.booleanlist',  'published', 'class="inputbox"', $published );

		$lists['editedby']             = JHTML::_('select.booleanlist',  'editedby', 'class="inputbox"', $book->editedby );

		$which_user = $isNew ? $user->id : $book->user_id;
		$lists['user_id']                       = JHTML::_('list.users',  'user_id', $which_user, 1, NULL, 'name', 0 );

		$lists['access']                        = JHTML::_('list.accesslevel',  $book);

		JHTML::_('behavior.tooltip');

                $lists['credit']=JHTML::_('credit.credit');

		$this->assignRef( 'session',    JFactory::getSession());
                $this->assignRef( 'params',             $params);
		$this->assignRef( 'imageconfig',             $imageconfig);	
		$this->assignRef('book',		$book);
		$this->assignRef('lists',               $lists);
		$this->assignRef('pane',               $pane);
		//passo la palla al template view/book/tpml/form.php
		parent::display($tpl);
	}
}
