<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );

class AbookViewCategory extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option;
		$document       = & JFactory::getDocument();
                $document->addStyleSheet('components/'.$option.'/css/'.$option.'.css');
		$category		=& $this->get('Data');
		$isNew		= ($category->id < 1);

		//unisco in un unico array l'elento delle categorie e la voce top (livello padre)
		$cat          =& $this->get('Categorieslist2');
		$top[]    = JHTML::_('select.option','0', JText::_('TOP'), 'id', 'treename');
		$categorieslist2=array_merge($top, $cat);

		$text = $isNew ? JText::_( 'NEW' ) : JText::_( 'EDIT' );
		$icon = $isNew ? "jcategoryadd" : "jcategoryedit";
		JToolBarHelper::title(   JText::_( 'NEW CATEGORY' ).': <small><small>[ ' . $text.' ]</small></small>', $icon );
		JToolBarHelper::save();
		JToolBarHelper::apply();
		if ($isNew)  {
			JToolBarHelper::cancel();
		} else {
			// for existing items the button is renamed `close`
			JToolBarHelper::cancel( 'cancel', 'Close' );
			$lists['access']                        = JHTML::_('list.accesslevel',  $category);
		}

		$published = ($category->id) ? $category->published : 1;
                $lists['published']             = JHTML::_('select.booleanlist',  'published', 'class="inputbox"', $published );

		$lists['access']                        = JHTML::_('list.accesslevel',  $category);
		$lists['parent'] = JHTML::_('select.genericlist', $categorieslist2, 'parent_id', '','id', 'treename', @$category->parent_id );

		$query= &$this->get('Ordering');
		$catid=$category->id < 1?'':$category->id;
                $lists['ordering']                      = JHTML::_('list.specificordering',$category, $catid, $query );

		$params =& JComponentHelper::getParams( 'com_abook' );
                $img['cat_img_path'] = $params->get( 'cat_img_path' );
                //tendina con le immagini
                $lists['images'] = JHTML::_('list.images', 'catimage', $category->catimage, '', DS.'images'.DS.$img['cat_img_path'].DS);
	
		JHTML::_('behavior.tooltip');

		JHTML::addIncludePath(JPATH_COMPONENT.DS.'helpers');
                $lists['credit']=JHTML::_('credit.credit');
	
		$this->assignRef('category',		$category);
		$this->assignRef('lists',               $lists);

		parent::display($tpl);
	}
}
