<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.helper');
class AbookHelperRoute
{
	function getBookRoute($id, $catid = 0)
        {
                $needles = array(
                        'book'  => (int) $id,
                        'category' => (int) $catid,
                );

                //Create the link
                $link = 'index.php?option=com_abook&view=book&id='. $id;

                if($catid) {
                        $link .= '&catid='.$catid;
                }

                if($item = AbookHelperRoute::_findItem($needles)) {
                        $link .= '&Itemid='.$item->id;
                };
                return $link;
        }

	function getCategoryRoute($catid)
        {
                $needles = array(
                        'category' => (int) $catid,
                );

                //Create the link
                $link = 'index.php?option=com_abook&view=category&id='.$catid;

                if($item = AbookHelperRoute::_findItem($needles)) {
                        if(isset($item->query['layout'])) {
                                $link .= '&layout='.$item->query['layout'];
                        }
                        $link .= '&Itemid='.$item->id;
                };

                return $link;
        }

        function _findItem($needles)
        {
                $component =& JComponentHelper::getComponent('com_abook');

                //$menus  = & JSite::getMenu();
		$menus  = &JApplication::getMenu('site', array());
                $items  = $menus->getItems('componentid', $component->id);
                $match = null;

                foreach($needles as $needle => $id)
                {
                        foreach($items as $item)
                        {
                                if ((@$item->query['view'] == $needle) && (@$item->query['id'] == $id)) {
                                        $match = $item;
                                        break;
                                }
                        }

                        if(isset($match)) {
                                break;
                        }
                }

                return $match;
        }
}
?>
