<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class AbookModelAuthor extends JModel
{
	var $_data;
	var $_total = null;
	var $_pagination = null;
        var $_id = null;

        function __construct()
        {
                parent::__construct();

                global $mainframe, $option;

		$params = &$mainframe->getParams();
		$params = &JComponentHelper::getParams( 'com_abook' );
                $pag=$params->get( 'bookpagination' );
                // Get the pagination request variables
                $limit          = $mainframe->getUserStateFromRequest( $option.'.limit', 'limit', $pag, 'int' );
                $limitstart     = JRequest::getVar( 'limitstart', 0, '', 'int' );
                // In case limit has been changed, adjust limitstart accordingly
                $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

                $this->setState('limit', $limit);
                $this->setState('limitstart', $limitstart);
                $array = JRequest::getVar('id',  0, '', 'array');
                $this->setId((int)$array[0]);
        }

        function setId($id)
        {
                // Set id and wipe data
                $this->_id       = $id;
                $this->_data = null;
        }

	function _buildQuery()
	{
                $where          = $this->_buildContentWhere();
                $orderby        = $this->_buildContentOrderBy();
		
		$query = "SELECT book.*, "
		. ' CASE WHEN CHAR_LENGTH(book.alias) THEN CONCAT_WS(\':\', book.id, book.alias) ELSE book.id END as slug, '
		. ' CASE WHEN CHAR_LENGTH(cat.alias) THEN CONCAT_WS(\':\', cat.id, cat.alias) ELSE cat.id END as catslug, '
		. ' ROUND( v.rating_sum / v.rating_count ) AS rating, v.rating_count '
		. ' FROM #__abbookauth AS authbook '
		. ' JOIN #__abbook AS book ON authbook.idbook=book.id '
		. ' JOIN #__abcategories AS cat ON cat.id=book.catid '
		. ' JOIN #__abauthor AS author ON author.id=authbook.idauth '
		. ' LEFT JOIN #__abrating AS v ON book.id = v.book_id '
		. $where
		. $orderby
		;
		return $query;
	}

        function _buildContentOrderBy()
        {
		$config =& JComponentHelper::getParams( 'com_abook' );
		$order=$config->get( 'display_order' );
                $order_dir=$config->get( 'display_order_dir', "ASC" );
		$orderby        = ' ORDER BY '.$order.' '.$order_dir;
                return $orderby;
        }

        function _buildContentWhere()
        {
                global $mainframe, $option;
                $db                                     =& JFactory::getDBO();
                $filter_order           = $mainframe->getUserStateFromRequest( $option.'.categories.filter_order', 'filter_order', 'name', 'cmd' );
                $filter_order_Dir       = $mainframe->getUserStateFromRequest( $option.'.categories.filter_order_Dir', 'filter_order_Dir', '', 'word' );
                $search                 = $mainframe->getUserStateFromRequest( $option.'.categories.search', 'search', '', 'string' );
                $search                         = JString::strtolower( $search );

                $where = array();

                if ($search) {
                        $where[] = 'LOWER(name) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
                }
		
		$where[] = "author.id=" .$this->_id;
		$where[] = "book.published = 1";
		$where[] = "cat.published = 1";

                $where          = ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );

                return $where;
        }

	function getData()
	{
		// Lets load the data if it doesn't already exist
		if (empty( $this->_data ))
		{
                       	$query = $this->_buildQuery();
                       	$this->_data = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit') );
                	}
			$k=0;
			foreach($this->_data as $libro){
				$this->_authorname($libro->id);
				$this->_data[$k]->authors=$this->_authorname;
				$k=$k+1;
			}
		return $this->_data;
	}

       function _Authorname($idbook)
        {
                // Lets load the content if it doesn't already exist
                $query = 'SELECT a.name AS author, a.id AS idauthor' .
                         ' FROM #__abbookauth AS b'.
                         ' JOIN #__abauthor AS a ON a.id = b.idauth' .
                         ' WHERE b.idbook = '. (int) $idbook;
                $this->_db->setQuery($query);
                $this->_authorname = $this->_db->loadResultArray();
		$this->_authorname = implode(', ', $this->_authorname);
                return $this->_authorname;
        }


        function getTotal()
        {
                // Lets load the content if it doesn't already exist
                if (empty($this->_total))
                {
                        $query = $this->_buildQuery();
                        $this->_total = $this->_getListCount($query);
                }

                return $this->_total;
        }

        function getPagination()
        {
                // Lets load the content if it doesn't already exist
                if (empty($this->_pagination))
                {
                        jimport('joomla.html.pagination');
                        $this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
                }

                return $this->_pagination;
        }

        function &getAuthor()
        {
                // Load the data
                if (empty( $this->_author )) {
                        $author =& $this->getTable('author');
                        if (!$author->load($this->_id)) {
                                $this->setError($this->_db->getErrorMsg());
                                return false;
                        }
                }
                $this->_author = $author;
                return $this->_author;
        }
}
