<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class AbookModelBook extends JModel
{
        var $_id = null;
        var $_data = null;

	function __construct()
	{
		parent::__construct();
		global $mainframe, $option;
		$id = JRequest::getVar('id', 0, '', 'int');
		$this->setId((int)$id);
	}

	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}

	function &getData()
	{
		// Load the data
		if (empty( $this->_data )) {
			$libro =& $this->getTable();
                	if (!$libro->load($this->_id)) {
                       		$this->setError($this->_db->getErrorMsg());
                       		return false;
               		}
		}
		$this->_data = $libro;
		return $this->_data;
	}

        function &getCatname()
        {
                // Load the data
                if (empty( $this->_catname )) {
                        $cat =& $this->getTable('category');
                        if (!$cat->load($this->_data->catid)) {
                                $this->setError($this->_db->getErrorMsg());
                                return false;
                        }
                        $parent[0]->id=$cat->id;
			$parent[0]->name=$cat->name;
			$parent[0]->slug=$cat->id.':'.$cat->alias;
			$parent[0]->published=$cat->published;
			$parent[0]->access=$cat->access;
			$k=1;
                        while ($cat->parent_id!=0) {
                                $cat->load($cat->parent_id);
				$parent[$k]->id=$cat->id;
                        	$parent[$k]->name=$cat->name;
				$parent[$k]->slug=$cat->id.':'.$cat->alias;
				$parent[$k]->published=$cat->published;
				$parent[$k]->access=$cat->access;
				$k=$k+1;
                        }
                }
                $this->_catname = $parent;
                return $this->_catname;
        }

	function &getLocationname()
        {
                // Load the data
                if (empty( $this->_locationname )) {
                        $location =& $this->getTable('location');
                        if (!$location->load($this->_data->idlocation)) {
                                $this->setError($this->_db->getErrorMsg());
                        }
                }
                $this->_locationname = $location->location;
                return $this->_locationname;
        }	

        function &getEditorname()
        {
                // Load the data
                if (empty( $this->_editorname )) {
                        $editor =& $this->getTable('editor');
                        if (!$editor->load($this->_data->ideditor)) {
                                $this->setError($this->_db->getErrorMsg());
                        }
                }
                $this->_editorname = $editor->name;
                return $this->_editorname;
        }

        function &getLibraryname()
        {
                // Load the data
                if (empty( $this->_libraryname )) {
                        $library =& $this->getTable('library');
                        if (!$library->load($this->_data->idlibrary)) {
                                $this->setError($this->_db->getErrorMsg());
                        }
                }
                $this->_libraryname = $library->name;
                return $this->_libraryname;
        }

       function &getAuthorname()
        {
                // Lets load the content if it doesn't already exist
                if (empty($this->_authorname))
                {
                        $query='SELECT a.name AS author, a.id AS idauthor, ' .
			       "\n CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(':', a.id, a.alias) ELSE a.id END as slug ".
                               ' FROM #__abbookauth AS b'.
                               ' JOIN #__abauthor AS a ON a.id = b.idauth' .
                               ' WHERE b.idbook = '. (int) $this->_id .
				' ORDER BY author ASC '
				;
                        $this->_db->setQuery($query);
                        $this->_authorname = $this->_db->loadObjectList();
                }
                return $this->_authorname;
        }
	
        function &getVoting()
        {
		if (empty($this->_voting)){
			$query='SELECT ROUND( v.rating_sum / v.rating_count ) AS rating, v.rating_count'
				.' FROM #__abbook AS a'
				.' LEFT JOIN #__abrating AS v ON a.id = v.book_id'
				.' WHERE a.id='. (int) $this->_id;
			$this->_db->setQuery($query);
			$this->_voting = $this->_db->loadAssoc();
		}
                return $this->_voting;
        }

	function storeVote($rate)
        {
                if ( $rate >= 1 && $rate <= 5){
                        $userIP =  $_SERVER['REMOTE_ADDR'];
                        $query = 'SELECT *' .
                                        ' FROM #__abrating' .
                                        ' WHERE book_id = '.(int) $this->_id;
                        $this->_db->setQuery($query);
                        $rating = $this->_db->loadObject();

                        if (!$rating){
                                // There are no ratings yet, so lets insert our rating
                                $query = 'INSERT INTO #__abrating ( book_id, lastip, rating_sum, rating_count )' .
                                                ' VALUES ( '.(int) $this->_id.', '.$this->_db->Quote($userIP).', '.(int) $rate.', 1 )';
                                $this->_db->setQuery($query);
                                if (!$this->_db->query()) {
                                        JError::raiseError( 500, $this->_db->stderr());
                                }
                        }else{
                                if ($userIP != ($rating->lastip)){
                                        // We weren't the last voter so lets add our vote to the ratings totals for the article
                                        $query = 'UPDATE #__abrating' .
                                                        ' SET rating_count = rating_count + 1, rating_sum = rating_sum + '.(int) $rate.', lastip = '.$this->_db->Quote($userIP) .
                                                        ' WHERE book_id = '.(int) $this->_id;
                                        $this->_db->setQuery($query);
                                        if (!$this->_db->query()) {
                                                JError::raiseError( 500, $this->_db->stderr());
                                        }
                                }else{
                                        return false;
                                }
                        }
                        return true;
                }
                JError::raiseWarning( 'SOME_ERROR_CODE', 'Article Rating:: Invalid Rating:' .$rate, "JModelArticle::storeVote($rate)");
                return false;
        }

	function hit()
        {
                global $mainframe;

                if ($this->_id)
                {
                        $book = & $this->getTable();
                        $book->hit($this->_id);
                        return true;
                }
                return false;
        }
	
	function &getImageinfo()
	{
		$params =& JComponentHelper::getParams( 'com_abook' );
		$this->_imageinfo = @getimagesize('images' .DS .$params->get( 'img_path' ).DS.$this->_data->image);
                return $this->_imageinfo;
	}
}
