<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class AbookModelSearch extends JModel
{
        var $_data = null;
	var $_total = null;
	var $_pagination = null;

	function __construct()
	{
		parent::__construct();
		global $mainframe, $option;

                //Get configuration
                $config = JFactory::getConfig();
		$params = &JComponentHelper::getParams( 'com_abook' );
		//retreive params menu
		$menus           = & JSite::getMenu();
                $menu           = $menus->getActive();
                if (is_object( $menu )) {
                        $menu_params = new JParameter( $menu->params );
			$this->typesearch=$menu_params->get('typesearch', 0);
                        $this->catid=$this->typesearch?$menu_params->get('catid', 0):0;
                }else {
                        $this->catid=0;
                }
		//end retreive params menu
                $pag=$params->get( 'bookpagination' );
                $limit          = $mainframe->getUserStateFromRequest( $option.'.limit', 'limit', $pag, 'int' );
               	$limitstart = JRequest::getVar('limitstart', 0, '', 'int'); 
		// In case limit has been changed, adjust limitstart accordingly
                $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
	
                $this->setState('limit', $limit);
                $this->setState('limitstart', $limitstart);

                // Set the search parameters
                $keyword                = urldecode(JRequest::getString('keyword'));
		if(isset($keyword)) {
                        $this->setState('keyword', $keyword);
                }
		$category = JRequest::getVar('category');
		if(isset($category)) {
			$this->setState('category', $category);
		}
		$location = JRequest::getVar('location');
		if(isset($location)) {
                        $this->setState('location', $location);
                }
		$author = JRequest::getVar('author');
                if(isset($author)) {
                        $this->setState('author', $author);
                }
		$ideditor = JRequest::getVar('ideditor');
		if(isset($ideditor)) {
                        $this->setState('ideditor', $ideditor);
                }
		$author = JRequest::getVar('author');
		if(isset($author)) {
                        $this->setState('author', $author);
                }
		$year = JRequest::getVar('year');
		if(isset($year)) {
                        $this->setState('year', $year);
                }
		$library = JRequest::getVar('library');
		if(isset($library)) {
                        $this->setState('library', $library);
                }
	}

	function getKey()
        {
		$searchparam = null;
		if (($this->getState('keyword'))!=''){
                        $searchparam['keyword']= $this->getState('keyword');
			$searchparamid['keyword']= "((a.title LIKE '%" .$this->getState('keyword') ."%') OR (a.html LIKE '%" .$this->getState('keyword') ."%') OR (cat.name LIKE '%" .$this->getState('keyword') ."%') OR (a.catalogo LIKE '%" .$this->getState('keyword') ."%'))";
                }
                if (($this->getState('category'))!=''){
                        $searchparam['category']=$this->getState('category');
			$searchparamid['category']="catid=" .$this->getState('category');
		}
                if (($this->getState('location'))!=''){
                        $searchparam['location']=$this->getState('location');
			$searchparamid['location']="idlocation=" .$this->getState('location');
                }
		if (($this->getState('author'))!=''){
                        $searchparam['author']=$this->getState('author');
                        $searchparamid['author']="idauth=" .$this->getState('author');
                }
                if (($this->getState('ideditor'))!=''){
                        $searchparam['ideditor']=$this->getState('ideditor');
			$searchparamid['ideditor']="ideditor=" .$this->getState('ideditor');
                }
                if (($this->getState('year'))!=''){
                        $searchparam['year']=$this->getState('year');
			$searchparamid['year']="year=" .$this->getState('year');
                }
                if (($this->getState('library'))!=''){
                        $searchparam['library']=$this->getState('library');
			$searchparamid['library']="idlibrary=" .$this->getState('library');
		}
		if(isset($searchparamid)) {
                        $this->setState('searchparamid', $searchparamid);
                }
		return $searchparam;
        }

	function _buildQuery()
	{
			$user           =& JFactory::getUser();
			$where=$this->getKey();
			$where=$this->getState('searchparamid');
			if ($this->typesearch == 1) {
				$cat=$this->selectedcat();
				$where[] = "a.catid IN (".$cat .") ";
			}
			$where[]="a.published=1";
			$where[]="cat.published=1";
			$where[] = "a.access <=".(int) $user->gid;
			$where = ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );
			$orderby        = $this->_buildContentOrderBy();
                        $query = " SELECT a.*, a.title AS booktitle, cat.title AS cattitle, "
			. " CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(':', a.id, a.alias) ELSE a.id END as slug, "
			. " CASE WHEN CHAR_LENGTH(cat.alias) THEN CONCAT_WS(':', cat.id, cat.alias) ELSE cat.id END as slugcat, "
			. ' ROUND( v.rating_sum / v.rating_count ) AS rating, v.rating_count '
                        . ' FROM #__abbook AS a'
			. ' LEFT JOIN #__abbookauth AS aa ON aa.idbook = a.id '
			//. ' LEFT JOIN #__abauthor AS bb ON bb.id=aa.idauth '
			. ' LEFT JOIN #__abcategories AS cat ON a.catid=cat.id ' 
			. ' LEFT JOIN #__abrating AS v ON a.id = v.book_id '
			. $where
			. ' GROUP BY a.id '
			. $orderby
                        ;
                return $query;
	}

	function _buildContentOrderBy()
        {
                global $mainframe, $option;
                $config =& JComponentHelper::getParams( 'com_abook' );
                $order=$config->get( 'display_order' );
                if ($order=="title"){
                        $order="booktitle";
                }
                $order_dir=$config->get( 'display_order_dir', "ASC" );
                $orderby        = ' ORDER BY '.$order.' '.$order_dir;
                return $orderby;
        }

	function getData()
        {
                // Lets load the data if it doesn't already exist
                if (empty( $this->_data ))
                {
                        $query = $this->_buildQuery();
                        $this->_data = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit')  );
			$total = count($this->_data);
			for($i = 0; $i < $total; $i++)
                        {
                                $item =& $this->_data[$i];
                                $item->author = $this->getAuthors($item->id);
                        }
                }
                return $this->_data;
        }

	function getAuthors($idbook)
        {
                $query = "SELECT idbook, GROUP_CONCAT(name ORDER BY name ASC SEPARATOR ', ') AS author "
                . "\n FROM #__abbookauth "
                . ' LEFT JOIN #__abauthor ON id=idauth '
                . ' WHERE  idbook='.$idbook
                . ' GROUP BY idbook '
                ;
                $this->_db->setQuery($query);
                $authors=$this->_db->loadObject();
                return $authors->author;
        }

	function getTotal()
        {
		if (empty($this->_total))
                {
                        $query = $this->_buildQuery();
                        $this->_total = $this->_getListCount($query);
                }
                return $this->_total;
        }

        function getPagination()
        {
                // Lets load the content if it doesn't already exist
                if (empty($this->_pagination))
                {
                        jimport('joomla.html.pagination');
                        $this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
                }

                return $this->_pagination;
        }


	function &getCategorieslist() {
        	if (empty( $this->_categorieslist )) {
                	$query = ' SELECT *'
                		. ' FROM #__abcategories'
				. ' WHERE published=1'
				. ' ORDER BY name '
                        	;
                        $this->_db->setQuery( $query );
                        $rows = $this->_getList( $query );
                }
                $children = array();
                        // first pass - collect children
                        foreach ($rows as $v ){
                                $pt = $v->parent_id;
                                $list = @$children[$pt] ? $children[$pt] : array();
                                array_push( $list, $v );
                                $children[$pt] = $list;
                        }
                        // second pass - get an indent list of the items
			JHTML::addIncludePath(JPATH_COMPONENT.DS.'helpers');
                        $this->_categorieslist = JHTML::_('menu.treerecurse', $this->catid, '', '', array(), $children);

                return $this->_categorieslist;
        }

	function selectedcat() {
                if (empty($this->allcatid)){
                        //retrieve all category id array
                       	$idsarray[]=$this->catid;
                        foreach ($this->_categorieslist as $catid){
       	                        $idsarray[]= $catid->id;
               	        }
                       	$ids = implode( ',', $idsarray );
                        //$catCondition = ' WHERE b.id IN ('.$ids.')';
       	                $this->allcatid=$ids;
               	        //end retrieve all category id array
		}
                return $this->allcatid;
        }
        function &getEditorslist() {
                if (empty( $this->_editorslist )) {
			if ($this->typesearch == 1) {
				$cat=$this->selectedcat();
				$query = ' SELECT DISTINCT e.id, e.name '
        	                . ' FROM #__abbook as b'
                	        . ' JOIN #__abeditor as e on e.id=b.ideditor'
                        	. ' WHERE b.catid IN ('.$cat .')'
	                        . ' ORDER BY e.name '
        	                ;
			}else{
                                $query = ' SELECT id, name '
                                . " FROM #__abeditor "
                                . " ORDER BY name";
                        }
                        $this->_db->setQuery( $query );
                        $this->_editorslist = $this->_getList( $query );
                }

                return $this->_editorslist;
        }

	function &getLibrarieslist() {
                if (empty( $this->_librarieslist )) {
			if ($this->typesearch == 1) {
				$cat=$this->selectedcat();
	                        $query = ' SELECT DISTINCT e.id, e.name '
				. ' FROM #__abbook as b'
				. ' JOIN #__ablibrary as e on e.id=b.idlibrary'
				. ' WHERE b.catid IN ('.$cat .')'
				. ' ORDER BY e.name '
                        	;
			}else{
				$query = ' SELECT * '
                                . " FROM #__ablibrary "
                                . " ORDER BY name";
                        }
                        $this->_db->setQuery( $query );
                        $this->_librarieslist = $this->_getList( $query );
                }
                return $this->_librarieslist;
        }

        function &getLocationslist() {
                if (empty( $this->_locationslist )) {
			if ($this->typesearch == 1) {
				$cat=$this->selectedcat();
	                        $query = ' SELECT DISTINCT e.id, e.location '
        	                . ' FROM #__abbook as b'
				. ' JOIN #__ablocations as e on e.id=b.idlocation'
				. ' WHERE b.catid IN ('.$cat .')'
				. ' ORDER BY location '
                        	;
			}else{
                                $query = ' SELECT id, location '
                                . " FROM #__ablocations "
                                . " ORDER BY location";
                        }
                        $this->_db->setQuery( $query );
                        $this->_locationslist = $this->_getList( $query );
                }

                return $this->_locationslist;
        }

	function &getAuthorslist() {
                if (empty( $this->_authorslist )) {
			if ($this->typesearch == 1) {
                       		$cat=$this->selectedcat();
	                        $query = ' SELECT DISTINCT a.id, a.name '
        	                        . " FROM #__abbook as b "
                	                . " JOIN #__abbookauth as ba on ba.idbook=b.id "
                        	        . " JOIN #__abauthor as a on a.id=ba.idauth "
                                	. " WHERE b.catid IN (".$cat.")"
	                                . " ORDER BY a.name"; 
			}else{
				$query = ' SELECT id, name '
				. " FROM #__abauthor "
				. " ORDER BY name";
			}
                        $this->_db->setQuery( $query );
                        $this->_authorslist = $this->_getList( $query );
                }

                return $this->_authorslist;
        }

	function &getYearlist() {
                if (empty( $this->_yearlist )) {
                        if ($this->typesearch == 1) {
                                $cat=$this->selectedcat();
                                $query = ' SELECT DISTINCT year as id, year as name'
                                . ' FROM #__abbook '
                                . ' WHERE catid IN ('.$cat .')'
                                ;
                        }else{
                                $query = ' SELECT DISTINCT year as id, year as name'
                                . ' FROM #__abbook '
                                ;
                        }
                        $this->_db->setQuery( $query );
                        $this->_yearlist = $this->_getList( $query );
                }

                return $this->_yearlist;
        }
}
