<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

function AbookBuildRoute(&$query)
{
	$segments = array();

	if(isset($query['view']))
	{
	$segments[] = $query['view'];
        	unset( $query['view'] );
	}
	if(isset($query['catid']))
        {
        $segments[] = $query['catid'];
                unset( $query['catid'] );
        };
	if(isset($query['id']))
	{
	$segments[] = $query['id'];
        	unset( $query['id'] );
	};
	if(isset($query['keyword']))
        {
        $segments[0] = 'search';
        };
	return $segments;
}

function AbookParseRoute( $segments )
{
	$vars = array();
	switch($segments[0])
	{
		case 'categories':
                	$vars['view'] = 'categories';
                	break;
		case 'category':
                	$vars['view'] = 'category';
                	$id = explode( ':', $segments[1] );
                	$vars['id'] = (int) $id[0];
                	break;
		case 'book':
			$vars['view'] = 'book';
			$id = explode( ':', $segments[2] );
			$catid = explode( ':', $segments[1] );
			$vars['id'] = (int) $id[0];
			break;
		case 'author':
                        $vars['view'] = 'author';
                        $id = explode( ':', $segments[1] );
                        $vars['id'] = (int) $id[0];
                        break;
		case 'search':
			$vars['view'] = 'search';
			break;
       }
       return $vars;
}
