<?php 
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined('_JEXEC') or die('Restricted access'); ?>
<?php if ( $this->params->get( 'show_page_title', 1 ) ) : ?>
<div class="componentheading<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
        <?php echo $this->params->get( 'page_title' ); ?>
</div>
<?php endif; ?>
<?php if ($this->params->get( 'search' )== 1) { ?>
<div class="booksearch<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
        <form action="<?php echo JRoute::_( 'index.php?option=com_abook&view=search' ); ?>" method="post" name="adminForm" id="adminForm">
                <?php echo JHTML::_( 'form.token' ); ?>
                <table>
                <tr>
                        <td><input type="text" name="keyword" id="keyword" size="10" maxlength="50" value="" />
                        <input type="hidden" name="task" value="search" /></td>
                        <td><?php $img = JHTML::_('image.site', 'find.png', '/components/com_abook/images/', NULL, NULL, JText::_( 'Search' ), null, 0);?>
                        <input type="image" name="Search" value="<?php echo JText::_( 'Search' );?>" onclick="this.form.submit()" class="button" src="<?php echo $img;?>" /></td>
                </tr>
        </form>
                <tr>
                        <td>
                        <?php $searchlink = JRoute::_( 'index.php?option=com_abook&view=search');?>
                        <a href="<?php echo $searchlink; ?>"><?php echo JText::_('Advanced Search'); ?></a>
                        </td>
                </tr>
                </table>
</div>
<?php } ?>
<div style="clear:both"></div>
<?php if ($this->params->get( 'breadcrumb' )== 2) { ?>
<p><div> <a href="<?php echo JRoute::_('index.php?option=com_abook&view=categories');?>"><?php echo JText::_('BACK TO TOP'); ?></a></div></p><br />
<?php } ?>
<table class="contentpaneopen<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
	<tr>
		<td class="contentheading<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>"><?php echo $this->author->name;?></td>
	</tr>
        <tr>
		<td>
			<?php if ($this->author->image){
				echo '<a href="'.$this->lists['img_path'] .'/' .$this->author->image.'"
                        	style="cursor: pointer;" class="modal" title="'.$this->author->name.'">
                        	<img src="'.$this->lists['img_path'] .'/' .$this->author->image.'" width="100" alt="'.$this->author->name.'" 
				style="float:left;margin-bottom: 5px; margin-right: 5px;">
                        	</a>';
                	}?>
			<?php
			if ($this->author->html){ 
				echo $this->author->html;
			}?>
			<div style="clear:both;"></div>
			<hr class="separator">
			</td>
        </tr>
</table>
<br />
<table class="contentpaneopen<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
        <tfoot>
                <tr>
                        <td colspan="2"><?php echo $this->pagination->getPagesLinks(); ?></td>
                </tr>
        </tfoot>
		<tr>
			<td colspan="2" class="contentheading<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>"><?php echo JText::_('PUBLICATIONS BY AUTHOR');?><br /><br /></td>
		</tr>
        <?php
	$params = &JComponentHelper::getParams( 'com_abook' );
	$imgpath=$params->get( 'img_path' );
        $k = 0;
        $i = 0;
        $n = count( $this->items );
        $rows = &$this->items;
        foreach ($rows as $row) {
                $link           = JRoute::_( 'index.php?option=com_abook&view=book&catid='.$row->catslug.'&id='. $row->slug );
                ?>
                <tr class="sectiontableentry<?php echo $k+1; ?><?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
			<td width="100" height="100">
			<?php
				if ($row->image){
					echo '<a href="'.$link.'" title="'.JText::_('COVEROF').' '.$row->title.'"><img src="images/'.$imgpath.'/'.$row->image .'" width="80" alt="'.$row->title.'" hspace="5" vspace"5" /></a>';
				}else{
					echo '<a href="'.$link.'" title="'.JText::_('NOCOVEROF').' '.$row->title.'"><img src="components/com_abook/images/nocover.png" class="nocover" width="80" alt="'.JText::_('NOCOVEROF').' '.$row->title.'" hspace="5" vspace"5" /></a>';
				}
			?>
			</td>
                        <td width="90%">
                                <a href="<?php echo $link; ?>"><?php echo '<big><strong>' .$row->title .'</strong></big>';
					if ($row->subtitle){
						echo "<br /><em>" .$row->subtitle ."</em>";
					}?>
				</a><br />
				<p><?php echo JText::_('By') ." " .$row->authors;?></p>
				<br /><?php //rating
                                if ($params->get( 'view_rate' )){
                                        $html="";
                                        $img = '';

                                        // look for images in template if available
                                        $starImageOn    = JHTML::_('image.site',  'rating_star.png', '/images/M_images/' );
                                        $starImageOff   = JHTML::_('image.site',  'rating_star_blank.png', '/images/M_images/' );

                                        for ($i=0; $i < $row->rating; $i++) {
                                                $img .= $starImageOn;
                                        }
                                        for ($i=$row->rating; $i < 5; $i++) {
                                                $img .= $starImageOff;
                                        }
                                        $html .= '<span class="content_rating'.$this->escape($this->params->get('pageclass_sfx')).'">';
                                        $html .= JText::_( 'User Rating' ) .':'. $img .'&nbsp;/&nbsp;';
                                        $html .= intval( $row->rating_count );
                                        $html .= "</span>\n<br />\n";
                                        echo $html;
                                }?>
				<?php //jcomment integration
                                if ($params->get( 'jcomment' )==1){
                                $comments = JPATH_BASE . DS.'components'.DS.'com_jcomments'.DS.'jcomments.php';
                                        if (file_exists($comments)) {
                                                require_once($comments);
                                                $count = JComments::getCommentsCount($row->id, 'com_abook');
                                                echo '<a href="'.$link.'">';
                                                echo $count ? ('Comments('. $count . ')') : 'Add comment';
                                                echo '</a>';
                                        }
                                }/*jcomment integration - end*/?>
                        </td>
                </tr>
                <?php
                $k = 1 - $k;
                $i= 1 + $i;
        }
        ?>
		<tr>
        	        <td colspan="2">
                	        <div style="float:left;"></div>
                        	<div style="float:right;"><?php echo $this->lists['credit']; ?></div>
	                </td>
        	</tr>
        </table>
