<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );

class AbookViewBook extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option;
		$user           =& JFactory::getUser();
		$app =& JFactory::getApplication();
                $aid    = $user->get('aid');
		//get the book data and check if book is published 
		$book		=& $this->get('Data');
		if ($book->published!=1){
			$app->enqueueMessage( JText::_( 'ALERTNOTAUTH' ), 'error' );
			return;
                }
		//get the category data and check if category is published 
		$catname          =& $this->get('Catname');
		foreach ($catname as $cat){
			if ($cat->published!=1){
				$app->enqueueMessage( JText::_( 'ALERTNOTAUTH' ), 'error' );
				return;
                	}
			if ($cat->access > $aid){
				$app->enqueueMessage( JText::_( 'ALERTNOTAUTH' ).' '.JText::_('You must login first'), 'error' );
				return;
                        }
		}
		$lists['catname'] =array_reverse($catname);

		if ($book->access > $aid) {
                        $app->enqueueMessage( JText::_( 'ALERTNOTAUTH' ).' '.JText::_('You must login first'), 'error' );
			return;
		}
		$document       =& JFactory::getDocument();
                $document->addStyleSheet('components/'.$option.'/css/style.css');
                $pathway   =& $mainframe->getPathway();

		if ($book->metadesc) {
                        $document->setDescription( $book->metadesc );
                }
                if ($book->metakey) {
                        $document->setMetadata('keywords', $book->metakey);
                }

		$locationname		=& $this->get('Locationname');
		$lists['locationname'] = $locationname;

		$editorname          =& $this->get('Editorname');
                $lists['editorname'] = $editorname;

		$authorname          =& $this->get('Authorname');
		$lists['authors'] = $authorname;
		$libraryname          =& $this->get('Libraryname');
		$lists['library'] = $libraryname;
		//Get global parameters
		$params =& JComponentHelper::getParams( 'com_abook' );
                $lists['img_path'] = 'images' .'/' .$params->get( 'img_path' );
		$lists['file_path'] = JHTML::_('link', 'images/' .$params->get( 'file_path').'/'.$book->file, $book->file);
		$vote =& $this->get('Voting');

		$this->assignRef( 'session',    JFactory::getSession());

		$document->setTitle( $params->get( 'page_title' )." - ".$catname[0]->name." - ".$book->title);
		$comments = JPATH_BASE . '/components/com_jcomments/jcomments.php';

		jimport( 'joomla.user.user' );
		$authoruser=JUser::getInstance($book->user_id);
		$lists['authorreview'] = $book->created_by_alias ? $book->created_by_alias : $authoruser->name;
		#jcomment integration
		$checkprint=JFactory::getURI();
		$lists['checkprint']=array_key_exists("print", $checkprint->_vars)?$checkprint->_vars['print']:0;
		if ($lists['checkprint']!=1){
			if (file_exists($comments)) {
				require_once($comments);
				$jcomment=JComments::showComments($book->id, 'com_abook', $book->title);
				$this->assignRef('jcomment',               $jcomment);
			}
		}
		#jcomment integration - end
		JHTML::_('behavior.modal');
                $document->addScriptDeclaration("
		window.addEvent('domready', function() {
                        document.preview = SqueezeBox;
                });");

		JHTML::addIncludePath(JPATH_COMPONENT.DS.'helpers');
		
		$lists['print']=JHTML::_('icon.print_popup',  $book, $params, $book->access);
		$lists['print_screen']=JHTML::_('icon.print_screen',  $book, $params, $book->access);
		$print = JRequest::getBool('print');
                if ($print) {
                        $document->setMetaData('robots', 'noindex, nofollow');
                }
		$lists['credit']=JHTML::_('credit.credit');

		$lists['imageinfo']           =& $this->get('Imageinfo');


		//per vedere i plugin content
		$dispatcher     =& JDispatcher::getInstance();
		$book->text=$book->html;
		JPluginHelper::importPlugin('content');
		$results = $dispatcher->trigger('onPrepareContent', array (& $book, & $params, 0));
		$book->html=$book->text;
		//fine plugin


//*-------------
                $menus           = & JSite::getMenu();
                $menu           = $menus->getActive();
		if (is_object( $menu )) {
                        $menu_params = new JParameter( $menu->params );
                        if (!$menu_params->get( 'page_title')) {
                                $params->set('page_title', $params->get('comp_name'));
                        }
                } else {
                        $params->set('page_title',     $params->get('comp_name'));
                }
//------------*/

		$this->assignRef('book', $book);
		$this->assignRef('lists', $lists);
		$this->assignRef('vote', $vote);
		$this->assignRef('params', $params);
		$this->assignRef('print', $print);
		$this->assignRef('user', $user);

		if ($params->get( 'breadcrumb' ) == 1) {
		foreach ($lists['catname'] as $category){
			$pathway->addItem($category->name, 'index.php?option=com_abook&view=category&id='.$category->slug);
		}
		$pathway->addItem($book->title, '');
		}
		//passo la palla al template view/book/tpml/default.php
		parent::display($tpl);
	}
}
