<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class AbookViewBook extends JView
{
	function display($tpl = null)
	{
		global $mainframe;
		$user		=& JFactory::getUser();
		$aid    = $user->get('aid');
		$dispatcher	=& JDispatcher::getInstance();
		$app =& JFactory::getApplication();
		$book	= & $this->get( 'Data' );
		if ($book->published!=1){
                       $app->enqueueMessage( JText::_( 'ALERTNOTAUTH' ), 'error' ); 
			return;
                }
		if ($book->access > $aid) {
			$app->enqueueMessage( JText::_( 'ALERTNOTAUTH' ).' '.JText::_('You must login first'), 'error' );
			return;
		}
		//get the category data and check if category is published 
                $catname          =& $this->get('Catname');
                foreach ($catname as $cat){
                        if ($cat->published!=1){
                                $app->enqueueMessage( JText::_( 'ALERTNOTAUTH' ), 'error' );
				return;
                        }
                        if ($cat->access > $aid){
				$app->enqueueMessage( JText::_( 'ALERTNOTAUTH' ).' '.JText::_('You must login first'), 'error' );
				return;
                        }
                }
		$params 	= & JComponentHelper::getParams( 'com_abook' ); 

		$document = &JFactory::getDocument();

		// set document information
		$document->setTitle($book->title);
		$document->setName($book->alias);
		$document->setDescription($book->metadesc);
		$document->setMetaData('keywords', $book->metakey);

		// prepare header lines
		$document->setHeader($this->_getHeaderText($book, $params));

		$img_path = $params->get( 'img_path' );
		
		if ($book->image){
                        echo '<img src="images'.DS.$img_path.DS.$book->image.'" width="100" alt="'.$book->title.'" />';
                }else{
                        echo '<img src="components/com_abook/images/nocover.png" width="100" />';
                }

                $library         =& $this->get('Libraryname');
                if ($library){
                        echo "<br />";
                        echo JText::_( 'Library') . ": ".$library ;
                }

                $editor          =& $this->get('Editorname');
                if ($editor!=""){
                        echo "<br />";
                        echo JText::_( 'Editor') . ": ".$editor ;
                }

                $n=count($catname);
                $k=0;
		$categories="";
                foreach ($catname as $cat){
                        $k=$k +1;
                        $categories.=$cat->name;
                        if ($k!=$n) $categories.='->';
                }
                if ($categories!=""){
                        echo "<br />";
                        echo JText::_( 'Category') . ": ".$categories ;
                }
		if ($book->year!=0){
                        echo "<br />";
                        echo JText::_( 'Year') . ": ".$book->year ;
                }

		if ($book->pag!=0){
                        echo "<br />";
                        echo JText::_( 'Pages') . ": ".$book->pag ;
                }

		if ($book->catalogo!=""){
                        echo "<br />";
                        echo JText::_( 'Catalogo') . ": ".$book->catalogo ;
                }
	
		if ($book->price!=""){
                        echo "<br />";
                        echo JText::_( 'Price') . ": ".$book->price ;
                }
	
		if ($book->isbn!=""){
                        echo "<br />";
                        echo JText::_( 'isbn') . ": ".$book->isbn ;
                }

		if ($book->html!=""){
			echo "<hr>";
			echo "<strong>".JText::_( 'Review')."</strong><br />";
			echo $book->html;
		}
	}

	function _getHeaderText(& $book, & $params)
	{
		// Initialize some variables
		$text = '';
		if ($book->subtitle!=""){
			$text .= $book->subtitle;
		}

		$authors         =& $this->get('Authorname');
		$n=count($authors);
                $k=0;
		$listauthors="";
                foreach ($authors as $author){
	                $k=$k +1;
                        $listauthors.=$author->author;
                        if ($n != $k) $listauthors.= ", ";
                }
                if ($listauthors!=""){
                        $text .= "\n";
                        $text .= JText::_( 'By') . " ".$listauthors ;
                }

		return $text;
	}
}
?>
