<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );

class AbookViewCategory extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option;
		$app =& JFactory::getApplication();
		// Get data from the model
		$category	= & $this->get( 'Category');
		if ($category->published!=1){
			$app->enqueueMessage( JText::_( 'ALERTNOTAUTH' ), 'error' );
			return;
		}
		$user           =& JFactory::getUser();
                $aid    = $user->get('aid');
                if ($category->access > $aid) {
			$app->enqueueMessage( JText::_( 'ALERTNOTAUTH' ).' '.JText::_('You must login first'), 'error' );
			return;
                }
		$books          = & $this->get( 'Data');
		$params = &$mainframe->getParams();
		if ($params->get( 'breadcrumb' ) == 1) {
			$pathway   =& $mainframe->getPathway();
			if ($category->parent_id!=0){
				$parentcategory       = & $this->get( 'Parentcategory');
				foreach ($parentcategory as $parent){
                        		$pathway->addItem($parent->name, 'index.php?option=com_abook&view=category&id='.$parent->id.":".$parent->name);
                		}
			}
			$pathway->addItem($category->name, '');
                }
		$pagination = & $this->get( 'Pagination' );
		$subcategory = & $this->get( 'Subcategory' );
		$catname          =& $this->get('Catname');
		$lists['catname'] =array_reverse($catname);

		$document       =& JFactory::getDocument();
                $document->setTitle( $params->get( 'page_title' )." - ".$category->title);
                $document->addStyleSheet('components/'.$option.'/css/style.css');

		JHTML::addIncludePath(JPATH_COMPONENT.DS.'helpers');
                $lists['credit']=JHTML::_('credit.credit');

                //per vedere i plugin content
                $dispatcher     =& JDispatcher::getInstance();
                $category->text=$category->description;
                JPluginHelper::importPlugin('content');
                $results = $dispatcher->trigger('onPrepareContent', array (& $category, & $params, 0));
                $category->description=$category->text;
                //fine plugin
//*-----------------------------------
		$menus  = &JSite::getMenu();
                $menu   = $menus->getActive();
		if (is_object( $menu )) {
                        $menu_params = new JParameter( $menu->params );
                        if (!$menu_params->get( 'page_title')) {
                                $params->set('page_title', $params->get('comp_name'));
                        }
                } else {
                        $params->set('page_title', $params->get('comp_name')); 
                }
//----------------------------*/

		//$lists['itemid']=JRequest::getInt( 'Itemid' );
		// push data into the template
		$this->assignRef('books', $books);
		$this->assignRef('category', $category);
		$this->assignRef('pagination', $pagination);
		$this->assignRef('params', $params);
		$this->assignRef('subcategory', $subcategory);
		$this->assignRef('lists', $lists);		

		parent::display($tpl);
	}
}
